package apap.tugasindividu.singidol.model;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.time.LocalDateTime;
import java.util.List;

@Setter
@Getter
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "idol")
public class IdolModel {
    @Id
    @Size(max = 30)
    private String idolID;

    @NotNull
    @Size(max = 30)
    @Column(name = "nama_idol", nullable = false)
    private String namaIdol;

    @NotNull
    @Size(max = 30)
    @Column(name = "asal_negara", nullable = false)
    private String asalNegara;

    @NotNull
    @Column(name = "jumlah_angoota", nullable = false)
    private Integer jumlahAnggota;

    @NotNull
    @Column(nullable = false)
    @DateTimeFormat(pattern = "yyyy-MM-dd'T'HH:mm")
    private LocalDateTime tanggalDebut;

//    @NotNull
//    @Column(nullable = false)
//    @DateTimeFormat(pattern = "yyyy-MM-dd'T'HH:mm")
//    private LocalDateTime tanggalBerakhir;

    @OneToMany(mappedBy = "idol", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
    private List<PengajarModel> listPengajar;

    @ManyToMany
    @JoinTable(name = "penyelenggara_course", joinColumns = @JoinColumn(name = "code"), inverseJoinColumns = @JoinColumn(name = "no_penyelenggara"))
    List<PenyelenggaraModel> listPenyelenggara;
}
